#include<iostream>
#include<fstream>
#include<vector>

using namespace std;

int main()
{
	ifstream in("LADDER.IN");
	long long int t,k,n,m,c=0,z;
	vector<long long int> a;
	vector<bool> b;
	bool q=true;
	in>>t;
	for(int iii=1;iii<=t;iii++)
	{
		in>>n>>k;
		b.push_back(true);
		for(long long int i=1;i<=n;i++)
			b.push_back(false);
		a.push_back(0);
		for(long long int i=1;i<=n;i++)
			{
				in>>z;
				a.push_back(z);

		}
		if(n>k)
		{
		for(long long int i=1;i<=k;i++)
			b[i]=true;
		m=k;
		for(long long int i=1;i<=n;i++)
		{
			for(long long int j=1;j<=k;j++)
			{
				if(i+j<=n)
				{
				if(a[i+j]>a[i]&&b[i])
				{
					b[i+j]=true;
					m=max(m,i+j);
				}
				}
			}
			if(m<i-k) break;
		}
		cout<<m<<endl;
	m=0;
	b.clear();
	a.clear();
		}
		else cout<<n<<endl;
	
	}
	//system("pause");
	return 0;
}


/*

1
13 3
1 8 3 5 10 5 6 2 12 7 14 2 4

*/